#include <stdio.h>
#include <time.h>
#include <string.h>
#include "allegro.h"

#define W 640
#define H 480
#define hW W / 2
#define hH H / 2
#define tds typedef struct
#define R rand () %
#define X1 oph [0].x
#define Y1 oph [0].y
#define DX1 oph [0].dx
#define DY1 oph [0].dy
#define X2 oph[I].x
#define Y2 oph[I].y
#define Ver "V1.01"

tds {
  fixed x, y, z, sx, sy ;
} vertex ;

tds {
  unsigned char    v1, v2, v3, color ;
  vertex *vp ;
} face ;

tds {
  vertex  vt[100] ;
  face    faces [100] ;
  unsigned char nv, nf ;
} object3d ;

tds ph {
  fixed x, y, z ;
  fixed rx, ry, rz ;
  int   subtype, used, obi, cn, hurte, enemy, dx, dy, k ;
} ph ;

#define MAXOBJ 300
#define F      << 16
#define U	   >> 16
#define tpf    textprintf
#define tpfc   textprintf_centre
#define etl    text_length (font, e_t)

object3d     tos[6] ;
ph			 oph [MAXOBJ] ;

char		 e_t[] = { "COMPLETED" } ;
face         of [1000] ;
vertex       ov [1000], stars[500] ;
int          ovc, ofc, I, gameplaying = TRUE, bankstate, 
			 shotfired, shotx, shoty, ingm, dtmr, score, 
			 level, lcount, pattern, ptimer, pcount, kcount, missed, 
			 et, sc, lv, lt ;
BITMAP		 *dbf, *texture, *bb ;
PALETTE	     pal ;
RGB			 shiny ;
volatile int gametime ;
SAMPLE		 *sn1, *sn2, *sn3 ;

void gametimer(void) {
  gametime++ ;
}
END_OF_FUNCTION(gametimer);

object3d loadobject (char *filename) {
  object3d to ;
  PACKFILE *d ;
  
  d = pack_fopen (filename, "rp") ;

  pack_fread (&to.nv, sizeof (to.nv), d) ;
  pack_fread (&to.nf, sizeof (to.nf), d) ;
  for (I = 0; I < to.nv; I++)
    pack_fread (&to.vt[I], sizeof (vertex), d) ;
  
  for (I = 0; I < to.nf; I++)
    pack_fread (&to.faces[I], sizeof (face), d) ;
  pack_fclose (d) ;
  return (to) ;
}

void setup_models () {
  int      i, j ;
  MATRIX   matrix ;
  vertex   *o_v = ov ;
  face     *o_f = of ;
  object3d *ct ;

  for (i = 0; i < MAXOBJ; i++) {
	if (oph[i].used == 1) 
	  if (oph[i].subtype)
		i++ ;
	if (oph[i].used) {
	  get_transformation_matrix(&matrix, 1 F, oph[i].rx, oph[i].ry, oph[i].rz,
		oph[i].x, oph[i].y, oph[i].z) ;

	  ct = &tos[oph[i].obi] ;
	  for (j = 0; j < ct->nv; j++) {
		apply_matrix(&matrix, ct->vt[j].x, ct->vt[j].y, ct->vt[j].z, &o_v[j].x, &o_v[j].y, &o_v[j].z);
		persp_project(o_v[j].x, o_v[j].y, o_v[j].z, &o_v[j].sx, &o_v[j].sy);
	  }

	  for (j = 0; j < ct->nf; j++) {
		o_f [j] = ct->faces[j] ;
		o_f [j].vp = o_v ;
	  }
	  o_v += ct->nv ;
	  o_f += ct->nf ;
	  ovc += ct->nv ;
	  ofc += ct->nf ;
	}
  }
}

int tcmp(const void *e1, const void *e2)
{
   face *q1 = (face *)e1;
   face *q2 = (face *)e2;

   fixed d1 = q1->vp[q1->v1].z + q1->vp[q1->v2].z +
	      q1->vp[q1->v3].z ;
   fixed d2 = q2->vp[q2->v1].z + q2->vp[q2->v2].z +
	      q2->vp[q2->v3].z ;
   
   // Average Z
   /*d1 = q1->vp[q1->v1].z ;
   d1 += q1->vp[q1->v2].z ;
   d1 += q1->vp[q1->v3].z ;
   d1 = fdiv (d1, itofix (3)) ;
		  
   d2 = q2->vp[q2->v1].z ;
   d2 += q2->vp[q2->v2].z ;
   d2 += q2->vp[q2->v3].z ;
   d2 = fdiv (d2, itofix (3)) ;*/

   // fixed point
   /*d1 = q1->vp[q1->v3].z ;
   d2 = q2->vp[q2->v3].z ;*/
   
   // weighed percent
   /*d1 = q1->vp[q1->v1].z * itofix (0.33) ;
   d1 += q1->vp[q1->v2].z * itofix (0.33) ;
   d1 += q1->vp[q1->v3].z * itofix (0.33) ;
		  
   d2 = q2->vp[q2->v1].z * itofix (0.33) ;
   d2 += q2->vp[q2->v2].z * itofix (0.33) ;
   d2 += q2->vp[q2->v3].z * itofix (0.33) ;*/

   // furthest point
   /*if (q1->vp[q1->v2].z > d1)
	   d1 = q1->vp[q1->v2].z ;
   if (q1->vp[q1->v3].z > d1)
	   d1 = q1->vp[q1->v3].z ;

   if (q2->vp[q2->v2].z > d2)
	   d2 = q2->vp[q2->v2].z ;
   if (q2->vp[q2->v3].z > d2)
	   d2 = q2->vp[q2->v3].z ;*/

   // nearest point
   /*if (q1->vp[q1->v2].z < d1)
	   d1 = q1->vp[q1->v2].z ;
   if (q1->vp[q1->v3].z < d1)
	   d1 = q1->vp[q1->v3].z ;

   if (q2->vp[q2->v2].z < d2)
	   d2 = q2->vp[q2->v2].z ;
   if (q2->vp[q2->v3].z < d2)
	   d2 = q2->vp[q2->v3].z ;
*/
	 return d2 - d1;
}

void render_models () {
  short int i ;
  vertex *v1, *v2, *v3 ;
  face *fpr = of ;
  
  ovc = 0 ;
  ofc = 0 ;
  setup_models () ;

  qsort (of, ofc, sizeof (face), tcmp) ;

  for (i = 0; i < ofc; i++) {
    v1 = fpr->vp + fpr->v1 ;
    v2 = fpr->vp + fpr->v2 ;
    v3 = fpr->vp + fpr->v3 ;
    if (fmul(v2->x-v1->x, v3->y-v2->y) - fmul(v3->x-v2->x, v2->y-v1->y) > 0)
	  triangle (dbf, v1->sx U, v1->sy U, v2->sx U, v2->sy U, v3->sx U, v3->sy U, fpr->color) ;
	  //line (dbf, v1->sx U, v1->sy U, v2->sx U, v2->sy U, 15) ;
	  //line (dbf, v2->sx U, v2->sy U, v3->sx U, v3->sy U, 15) ;
	  //line (dbf, v3->sx U, v3->sy U, v1->sx U, v1->sy U, 15) ;
//	} else {
//	  line (dbf, v1->sx U, v1->sy U, v2->sx U, v2->sy U, 3) ;
//	  line (dbf, v2->sx U, v2->sy U, v3->sx U, v3->sy U, 3) ;
//	  line (dbf, v3->sx U, v3->sy U, v1->sx U, v1->sy U, 3) ;
	  
    fpr++ ;
  }
}

void addobj (int otype, fixed x, fixed y, fixed z, int subtype, int od) {
  for (I = 0; I < MAXOBJ; I++) {
    if (oph[I].used == 0) {
      memset (&oph[I], 0, sizeof (ph)) ;
	  oph[I].used = otype ;
	  oph[I].subtype = subtype ;
	  X2 = x ;
	  Y2 = y ;
	  oph[I].z = z ;
	  if (otype == 2) {
         oph[I].rx = 64 F ;
		 oph[I].obi = oph[I].hurte = shotfired = 1 ;
		 break ;
	  }
	  if (otype == 3) {
		 oph[I].enemy = oph[I].k = 1 ;
		 oph[I].obi = 2 ;
		 if (od == 1)
		   oph[I].obi = 4 ;
		 else if (od == 2)
		   oph[I].obi = 5 ;
		 break ;
	  }
	  if (otype == 4) {
		 oph[I].dx = -2 + R 5 ;
		 oph[I].dy = -2 + R 5 ;
		 oph[I].obi = 1 ;
		 break ;
	  }
	  if (otype == 5) {
		 oph[I].enemy = 1 ;
		 oph[I].obi = 3 ;
		 play_sample(sn2, 255, 128, 700, 0) ;
		 break ;
	  }
	}
  }
}

void animateobj () {
  for (I = 0; I < MAXOBJ; I++) {
    if (oph[I].used == 2) {
	  Y2 -= 5 F ;
	  if (Y2 < -60 F)
		  oph[I].used = shotfired = 0 ;
	}
    if (oph[I].used == 5) {
	  oph[I].rx += 10 F ;
	  oph[I].ry += 7 F ;
	  Y2 += 3 F ;
	  if (Y2 > 60 F)
		  oph[I].used = 0 ;
	}

    if (oph[I].used == 4) {
	  oph[I].rx += 10 F ;
	  oph[I].ry += 5 F ;
	  X2 += oph[I].dx F ;
	  Y2 += oph[I].dy F ;
	  oph[I].z -= 1 F ;
	  if (oph[I].z < 10 F)
		oph[I].used = 0 ;
	}
    if (oph[I].used == 3) {
	  sc = 200 - (level * 2) ;
	  if (sc < 50) sc = 50 ;
	  //sc = 50 ;
	  if (R sc == 10)
        addobj (5, X2, Y2, oph[I].z, 0, 0) ;

	  if (oph[I].subtype == 0) {
		if (oph[I].cn == 0) {
		  X2 -= 1 F ;
          if (X2 < -50 F)
			oph[I].cn = 1 ;
		}
		if (oph[I].cn == 1) {
		  X2 += 1 F ;
		  Y2 += 1 F ;
          if (Y2 > 50 F)
			oph[I].cn = 2 ;
		}
		if (oph[I].cn == 2) {
		  X2 += 2 F ;
		  Y2 -= 2 F ;
          if (X2 > 65 F)
			oph[I].used = 0 ;
		}
	  }
	  if (oph[I].subtype == 1) {
		if (oph[I].cn == 0) {
		  X2 += 2 F ;
          if (X2 > 50 F)
			oph[I].cn = 1 ;
		}
		if (oph[I].cn == 1) {
		  X2 -= 2 F ;
		  Y2 -= 2 F ;
          if (Y2 < -40 F)
			oph[I].cn = 2 ;
		}
		if (oph[I].cn == 2) {
		  X2 += 3 F ;
          if (X2 > 65 F)
			oph[I].used = 0 ;
		}
	  }
	  if (oph[I].subtype == 2) {
		if (oph[I].cn == 0) {
		  Y2 -= 1 F ;
          if (Y2 < -50 F)
			oph[I].cn = 1 ;
		}
		if (oph[I].cn == 1) {
		  X2 -= 1 F ;
		  Y2 += 2 F ;
          if (Y2 > 40 F)
			oph[I].cn = 2 ;
		}
		if (oph[I].cn == 2) {
		  X2 += 2 F ;
          if (X2 > 65 F)
			oph[I].used = 0 ;
		}
	  }
	  oph[I].rx += 5 F ;
	  oph[I].ry += 5 F ;
      if ((!oph[I].used) && (!dtmr))
		missed++ ;
	}
  }
}

void coldetect () {
  int ii, i3 ;

  for (I = 0; I < MAXOBJ; I++) {
	if (oph[I].used) {
      if (oph[I].enemy) {  // It's an enemy
		if ((X2 > (X1 - (5 F))) &&
		    (X2 < (X1 + (5 F))) &&
			(Y2 > (Y1 - (9 F))) &&
			(Y2 < (Y1 + (9 F)))) {
		  oph[I].used = 0 ;
		  for (i3 = 0; i3 < 50; i3++)
			addobj (4, X1, Y1, 80 F, 0, 0) ;
		  play_sample(sn1, 255, 128, 500, 0) ;
		  lv-- ; 
		  if (lv < 0) {
			oph[0].used = 0 ;
		    dtmr = 200 ;
		  } else {
			X1 = 0 F ;
			Y1 = 50 F ;
			lcount = 50 ;
			lt = 50 ;
			pattern = shotfired = 0 ;
			for (ii = 1; ii < MAXOBJ; ii++)
			  if (oph[ii].used != 4)
				oph[ii].used = 0 ;
		  }
		}
	  }
      if (oph[I].hurte) {  // It can hurt enemies
		for (ii = 1; ii < MAXOBJ; ii++) { 
		  if (oph[ii].used) {
			if ((X2 > (oph[ii].x - (6 F))) &&
				(X2 < (oph[ii].x + (6 F))) &&
				(Y2 > (oph[ii].y - (6 F))) &&
				(Y2 < (oph[ii].y + (6 F))) &&
				(I != ii) && (oph[ii].enemy) &&
				(oph[ii].k)) {
			  oph[ii].used = oph[I].used = shotfired = 0 ;
			  kcount++ ;
			  play_sample(sn1, 255, 128, 1000, 0) ;
			  if (!(kcount % 5)) {
				level++ ;
				if (level > 50)
				  dtmr = 400 ;
			  }
			  score += 1 + (oph[I].subtype + 1) ;
			  for (i3 = 0; i3 < 10; i3++)
      		    addobj (4, X2, Y2 - (1 F), 80 F, 0, 0) ;
			  break ;
			}
		  }
		}
	  }
	}
  }
}

void setup () {
  memset (&oph[0], 0, sizeof (ph) * MAXOBJ) ;
  oph[0].used = level = 1 ;
  oph[0].rx = 100 F ; ;
  oph[0].ry = oph[0].rz = kcount = missed = score = lt = 0 ;
  oph[0].z = 10 F ;
  lcount = 50 ;
  lv = 2 ;
}

void run () {
  if (!lcount) {
	if (!pattern) {
	  pattern = 1 + R 5 ;
	  ptimer = 0 ;
	  et = R 3 ;
	  pcount = 3 + R 4 + (level / 10) ;
	  if (pcount > 15)
		pcount = 15 ;
	}
	if (pattern) {
	  if (ptimer == 0) {
		if (pattern == 1)
		  addobj (3, 70 F, -40 F, 60 F, 0, et) ;
		if (pattern == 2)
		   addobj (3, 70 F, 0, 60 F, 0, et) ;
		if (pattern == 3)
		   addobj (3, -70 F, 0, 60 F, 1, et) ;
		if (pattern == 4)
		   addobj (3, -70 F, 50 F, 60 F, 1, et) ;
		if (pattern == 5)
		   addobj (3, 0 F, 70 F, 60 F, 2, et) ;
	  }
	  ptimer++ ;
	  if (ptimer > 15) {
		ptimer = 0 ;
		pcount-- ;
		if (!pcount) {
		  pattern = 0 ;
		  lcount = 100 - (level * 2);
		  if (lcount < 10)
			lcount = 10 ;
		}
	  }
	}
  } else
	lcount-- ;
}

int main () {
  srand (time(NULL)) ;
  allegro_init () ;
  install_keyboard();
  install_timer();
  LOCK_VARIABLE(gametime);
  LOCK_FUNCTION(gametimer);
  install_int(gametimer, 30);
  tos[0] = loadobject ("fight1.shf") ;
  tos[1] = loadobject ("shot1.shf") ;
  tos[2] = loadobject ("enemy1.shf") ;
  tos[3] = loadobject ("eshot1.shf") ;
  tos[4] = loadobject ("enemy2.shf") ;
  tos[5] = loadobject ("enemy3.shf") ;
  sn1 = load_voc ("snd1.voc") ;
  sn2 = load_voc ("snd2.voc") ;

  set_gfx_mode (GFX_AUTODETECT, W, H, 0, 0) ;
  install_sound (DIGI_AUTODETECT, MIDI_NONE, NULL) ;
  for (I = 0; I < 16; I++)
    pal[I].r = pal[I].g = pal[I].b = pal[I + 16].r = pal[I + 32].g = pal[I + 64].b = I * 4 ;
  set_palette (pal) ;
  set_projection_viewport(0, 0, W, H);
  dbf = create_bitmap (W, H);
  bb = create_bitmap (etl, 10) ;

  setup() ;
  text_mode (-1) ;
  for (I = 0; I < 500; I++) {
	 stars[I].sx = (R W) F ;
	 stars[I].sy = (R H) F ;
	 stars[I].x = (R 47) F ;
  }
  clear (bb) ;
  tpf (bb, font, 0, 0, 29, e_t) ;
  while (gameplaying) {
	clear (dbf) ;
	for (I = 0; I < 500; I++)
	  putpixel (dbf, stars[I].sx U, stars[I].sy U, stars[I].x U) ;
	render_models () ;
	if (!ingm) {
      tpfc (dbf, font, hW, hH, 47, "Yet Another Shooter " Ver " by FenrirWolf (aka David Grace)") ;
      tpfc (dbf, font, hW, hH + 15, 31, "Arrow keys move, spacebar fires.  Press SPACEBAR to play, ESC to quit.") ;
	} else
	  tpfc (dbf, font, hW, 0, 75, "Level %03i Score %07i Lives %i", level, score, lv + 1) ;
	if (dtmr) {
      line (dbf, 0, hH - 7, W, hH - 7, 27) ;
	  if (level > 50) {
	    masked_stretch_blit (bb, dbf, 0, 0, etl, 10, 0, 20, W, H / 2) ;
	    tpfc (dbf, font, hW, hH, 255, "You win!  So long, and thanks for the fish!") ;
	  }else
		tpfc (dbf, font, hW, hH, 255, "G A M E   O V E R") ;
      tpfc (dbf, font, hW, hH + 15, 15, "Raw Score: %i", score) ;
      tpfc (dbf, font, hW, hH + 25, 9, "Enemy Missed: %i", missed) ;
	  line (dbf, 0, hH + 38, W, hH + 38, 27) ;
      tpfc (dbf, font, hW, hH + 45, 47, "OVERALL SCORE: %05i", score - missed) ;
	}
    vsync();
	set_color (255, &shiny) ;
    blit(dbf, screen, 0, 0, 0, 0, W, H); 
	
	while (gametime) {
	  shiny.r = R 63 ;
	  shiny.g = R 63 ;
	  shiny.b = R 63 ;

	  if ((ingm) && (!dtmr)) {
		if (key[KEY_UP])
			DY1 = -2 F ;       
		if (key[KEY_DOWN])
			DY1 = 2 F ;
		bankstate = 0 ;
		if (key[KEY_LEFT]) {
			DX1 = -3 F ;
			bankstate = -1 ;
		  }
		if (key[KEY_RIGHT]) {
			DX1 = 3 F ;
			bankstate = 1 ;
		  }
		X1 += DX1 ;
		Y1 += DY1 ;
		if (Y1 < -50 F)
		  Y1 = -50 F ;
		if (Y1 > 50 F)
		  Y1 = 50 F ;
		if (X1 < -50 F)
		  X1 = -50 F ;
		if (X1 > 50 F)
		  X1 = 50 F ;
		
		  oph[0].cn = 0 ;
		  if (DX1 > 0)
			DX1 -= 1 F ;
		  else if (DX1 < 0)
			DX1 += 1 F ;
		  if (DY1 > 0)
			DY1 -= 1 F ;
		  else if (DY1 < 0)
			DY1 += 1 F ;

		if ((key[KEY_SPACE]) && (!shotfired)) {
		  addobj (2, X1, Y1 - (5 F), oph [0].z, 0, 0) ;
		  play_sample(sn2, 255, 128, 1000, 0) ;
		}
		if (bankstate != 0) {
		  if (bankstate == -1) 
			if (oph[0].rz > -20 F)
			  oph[0].rz -= 1 F ;
		  if (bankstate == 1) 
			if (oph[0].rz < 20 F)
			  oph[0].rz += 1 F ;
		} else {
		  if (oph[0].rz > 0)
			oph[0].rz -= 1 F ;
		  if (oph[0].rz < 0)
			oph[0].rz += 1 F ;
		}

		if (key[KEY_ESC]) {
		  ingm = 0 ;
		  clear_keybuf () ;
		  setup() ;
		}

		animateobj () ;
		coldetect() ;
		run () ;
	  } else if (!dtmr) {
		oph[0].ry += 1 F ;
		if (key[KEY_SPACE]) {
		  ingm = 1 ;
		  clear_keybuf() ;
		  memset (&oph[0], 0, sizeof (ph) * MAXOBJ) ;
		  oph[0].used = 1 ;
		  oph[0].rx = 64 F ;
		  Y1 = 49 F ;
		  oph [0].z = 60 F ;
		}
		if (key[KEY_ESC])
		  gameplaying = FALSE ;
	  } else {
		dtmr-- ;
		if (!dtmr) {
		  ingm = 0 ;
		  clear_keybuf () ;
		  setup() ;
		}
		animateobj() ;
	  }

	  for (I = 0; I < 500; I++) {
		 stars[I].sy += 5 F ;
		 if (stars[I].sy > (SCREEN_H F))
		   stars[I].sy = 0 F ;
    	 if (I % 2) 
		   stars[I].x = (R 47) F ;
	  }
	  if (lt) {
		lt-- ;
		oph[0].subtype = lt % 3 ;
	  }

	  gametime-- ;
    }
  }    
  destroy_bitmap (dbf) ;
  destroy_bitmap (bb) ;
  destroy_sample (sn1) ;
  destroy_sample (sn2) ;
  return (0) ;
}
END_OF_MAIN () ;
